#! /bin/bash
#
# Narcisse - Set the environment, to use with sh/ksh/bash
#
# Usage: cd THIS DIRECTORY; source .setenv
#

#set -x

if [ "x$NARCISSE_INITED" = "x" ]
then
	if [ "x$1" = "x" ]
	then
		export NARCISSE_ROOT=`pwd`
	else
		if [ `expr "$1" : '^/'` = "1" ]
		then
			export NARCISSE_ROOT=$1
		else
			export NARCISSE_ROOT="`pwd`/$1"
		fi
	fi
	if [ ! -e "$NARCISSE_ROOT/Core/sbin/chins.csh" ]
	then
		echo "ERROR - CANNOT FIND $NARCISSE_ROOT/Core/sbin/chins.csh"
		echo "        You should type: chdir narcisse_root_directory; source .setenv.sh"
		echo "        OR:              source .setenv narcisse_root_directory"
	else
		alias  Narcisse_root="cd $NARCISSE_ROOT"
		export ROOT_SBIN="$NARCISSE_ROOT/Core/sbin"
		export ROOT_BIN="$NARCISSE_ROOT/Core/bin"
		export PARALOOP="$NARCISSE_ROOT/Core/paraloop"

		# Add Core/sbin to the path
		PATH="$ROOT_SBIN:$ROOT_BIN:$PATH"

		# Some aliases to ease working in Narcisse
		alias Core="cd $NARCISSE_ROOT/Core"
		alias paraloop="$PARALOOP/bin/paraloop.pl"
		alias Core="cd $NARCISSE_ROOT/Core"
		alias Core_bin="cd $NARCISSE_ROOT/Core/bin"
		alias Core_sbin="cd $NARCISSE_ROOT/Core/sbin"
		alias Core_lib="cd $NARCISSE_ROOT/Core/lib"
		alias cgi-bin="cd $NARCISSE_ROOT/cgi-bin"
		alias last_sessdir=". $NARCISSE_ROOT/Core/sbin/last_sessdir.sh"
		alias chins=". $NARCISSE_ROOT/Core/sbin/chins.sh"
		export NARCISSE_INITED=1
	fi
fi
