use strict;
use warnings;

package Bio::Narcisse::AttributeAdaptor;

use Bio::EnsEMBL::Attribute;

use Bio::Narcisse::Utils::Exception qw(throw warning);

use vars qw(@ISA);

@ISA = qw( Bio::Narcisse::BaseFeatureAdaptor );


sub new {
  my $class = shift;

  my $self = $class->SUPER::new(@_);

  # cache creation could go here
  return $self;
}


sub fetch_all_by_Transcript{

	my ($self, $transcript) = @_;
	
	my $attr = [];
	
	return $attr;
}

sub fetch_all_by_Slice{
	my ($self, $slice) = @_;
	my $attr = [];
	
	my $sla = $self->db->get_SliceAdaptor;
	my $codon_table=$sla->karyotype->{$slice->seq_region_name}->{'codon_table'};
	
	if ( defined $codon_table && $codon_table =~ /\d+/ )
	{
		push @{$attr}, Bio::EnsEMBL::Attribute->new(-CODE => 'codon_table',
                                                -NAME => 'codon_table',
                                                -DESCRIPTION => "codon usage table",
                                                -VALUE => $codon_table);
	}				
	
	return $attr;
}

sub fetch_all_by_Translation{
	my ($self, $translation) = @_;
	
	my $attr = [];
	
	return $attr;
}

sub fetch_all_by_Gene{
	my ($self, $translation) = @_;
	
	my $attr = [];
	
	return $attr;
}

1;