=head1 NAME

Bio::Narcisse::Utils::Exception - Provides routines for printing error and warning messages

=head1 DESCRIPTION

Bio::Narcisse::Utils::Exception - Provides routines for printing error and warning messages.

=head1 SYNOPSIS

  

=head1 METHODS

=cut


package Bio::Narcisse::Utils::Exception;

use strict;
use warnings;

use LipmError;

use Exporter;
our @ISA = qw(Exporter);

our @EXPORT_OK = qw(
  throw
  warning
);

sub throw {
  my $string = shift;
  
  my $out = "\n-------------------- EXCEPTION --------------------\n" .
              "ERROR: $string\n" .
              "---------------------------------------------------\n";
#   die $out;
	throw LipmError( -text => $out, -value => 0001 );
  
}

sub warning{
	
	my $string = shift;
	my $out = "\n-------------------- WARNING ----------------------\n".
              "WARNING: $string\n".
  			  "---------------------------------------------------\n";
#   	print STDERR $out;
	throw LipmError( -text => $out, -value => 0000 );

}

1;
