#
# 	sebastien.letort@toulouse.inra.fr
#	Created: 25 March, 2009
#	$Id: GrepBased.pm 3142 2009-12-22 12:38:52Z manu $
#
# Copyright INRA/CNRS

# Emmanuel.Courcelle@toulouse.inra.fr
# Jerome.Gouzy@toulouse.inra.fr
# Thomas.Faraut@toulouse.inra.fr

# This software is a computer program whose purpose is to provide a
# web-based interface for analyzing the different levels of genome
# conservations.

# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".

# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.

# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.

# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.

package NarcisseService::GrepBased;

=pod

=head1 NAME

 NarcisseService::GrepBased - pas le temps

=head1  SYNOPSIS

 # code

=head1 DESCRIPTION

 #descr

=cut

use strict;
use warnings;

use Data::Dumper;

use base qw( NarcisseService );

#use General;

=head2 method _Init

 Usage        : my $o_x = New NarcisseService::GrepBased( -o_instance_obs =>,
                                                          -species =>,
                                                          -db => );
 Prerequisite : none
 Fonction     : initialise an instance of NarcisseService::GrepBased class.
 Returns      : a valid NarcisseService::GrepBased object
 Args         : !
 Attributes   :
    __o_logger, #inherited from LipmObject

    __?
=cut

sub _Init
{
	my $self = shift;

	# define _o_instance_obs and call TreatOptions
	$self->SUPER::_Init( @_ );

	# assert that what and from are not undef
#	LipmError::ParameterException::Assert( %h_args );

	

	return;
} # _Init


=head2 Procedure

 Title        : _TreatOptions
 Usage        : $o_xx->_TreatOptions( -species  => $species
                                      -db => $db );
 Prerequisite : called by NarcisseService::_Init
 Procedure    : set $species as attribute _species
 Args         : $species, string, short/long species name

=cut

sub _TreatOptions
{
	my $self   = shift;
	my %h_args = ( -species  => undef,
	               -db => 'prot',
	               @_ );

	#to set Instance_observer
	$self->SUPER::_TreatOptions( %h_args );

	my $o_inst_obs = $self->_Get( '_o_instance_obs' );
	my $ra_species = [];

	my $species    = $o_inst_obs->GetSpeciesShortName( $h_args{ -species } );

	my $db         = ( $h_args{ -db } =~ /prot/ ) ? 'prot' : 'nuc';

	my $file       = $o_inst_obs->GetDB( $db, $species );
	$self->_Set( __db_file => $file );

	return;
}



=head2 Function _GetDbFile

 Usage        : my $file = $o_x->_GetDbFile( none )
 Function     : .
 Returns      : $file
 Args         :
     none
 Error        : none

=cut

sub _GetDbFile
{
	my $self = shift;

	return $self->_Get( '__db_file' );
} #GetDbFile




1;

__END__

# Copyright INRA/CNRS

# Emmanuel.Courcelle@toulouse.inra.fr
# Jerome.Gouzy@toulouse.inra.fr
# Thomas.Faraut@toulouse.inra.fr

# This software is a computer program whose purpose is to provide a
# web-based interface for analyzing the different levels of genome
# conservations.

# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".

# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.

# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.

# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.
