# Copyright INRA/CNRS

# Emmanuel.Courcelle@toulouse.inra.fr
# Jerome.Gouzy@toulouse.inra.fr
# Thomas.Faraut@toulouse.inra.fr

# This software is a computer program whose purpose is to provide a
# web-based interface for analyzing the different levels of genome
# conservations.

# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".

# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.

# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.

# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.

package NarcisseServiceKeywords;

# I use constant to store keywords
# For coherence, we used plural keywords, API used singular
use constant NS_GENES        => 'Gene';
use constant NS_PROTEINS     => 'Protein';
use constant NS_TRANSCRIPTS  => 'Transcript';
use constant NS_SLICES       => 'Slice';

# not used by API
use constant NS_UPSTREAM   => 'upstream';
use constant NS_DOWNSTREAM => 'downstream';
use constant NS_CDS        => 'cds';

# keyword for type of output (out_type)
use constant NS_LOCUS => 'locus';
use constant NS_INFOS => 'infos';
use constant NS_FASTA => 'fasta';


#--------
our (@ISA, @EXPORT_OK);
BEGIN {
	require Exporter;
	@ISA = qw(Exporter);

	# symbols to export on request
	@EXPORT_OK = qw( &NS_GENES &NS_PROTEINS &NS_SLICES NS_TRANSCRIPTS
	                 &NS_UPSTREAM &NS_DOWNSTREAM &NS_CDS
	                 &NS_LOCUS &NS_INFOS &NS_FASTA );
}

=pod

=head1 COPYRIGHT NOTICE

This software is governed by the CeCILL license - www.cecill.info

=cut

1;