# Copyright INRA/CNRS

# Emmanuel.Courcelle@toulouse.inra.fr
# Jerome.Gouzy@toulouse.inra.fr
# Thomas.Faraut@toulouse.inra.fr

# This software is a computer program whose purpose is to provide a
# web-based interface for analyzing the different levels of genome
# conservations.

# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".

# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.

# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.

# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.

if [ "x$NARCISSE_INITED" == "x" ]
then
	echo "The NARCISSE environment is not yet started";
	exit 1
fi

cd $NARCISSE_ROOT
if [ "$1" == "" ]
then
	unset NARCISSE_CFG
	unalias Site
	unalias species
	unalias cfg
	unalias data
	unalias logs
	unalias update
	alias cgi-bin="cd $NARCISSE_ROOT/cgi-bin"
else
	if [ -d $NARCISSE_ROOT/$1 ]
    then
		NARCISSE_INSTANCE_NAME=$1
		cd $NARCISSE_ROOT/$NARCISSE_INSTANCE_NAME
		INSTANCE_ROOT="$NARCISSE_ROOT/$NARCISSE_INSTANCE_NAME"
		alias Instance_root="cd $INSTANCE_ROOT"
		export NARCISSE_CFG="$INSTANCE_ROOT/Site/cfg/narcisse.cfg"
		alias Site="cd $INSTANCE_ROOT/Site"
		alias species="cd $INSTANCE_ROOT/Site/species"
		alias cfg="cd $INSTANCE_ROOT/Site/cfg"
		alias data="cd `egrep '^ROOT_DATA=' $NARCISSE_CFG | cut -d '=' -f2`"
		alias logs="cd $INSTANCE_ROOT/Site/logs"
		alias update="cd $INSTANCE_ROOT/Site/update"
		alias cgi-bin="cd $INSTANCE_ROOT/cgi-bin"
		
		# This is useful ONLY in fast-cgi mode
		alias cgi-reload="(cd $INSTANCE_ROOT/cgi-bin;touch *)"

		if [ "$NARCISSE_INSTANCE_NAME" == "multi" ] && [ -r "$INSTANCE_ROOT/web_services/playmoby/.setenv" ] 
		then
			echo "WARNING !!! PLAYMOBY DOES NOT WORK WITH bash"
		fi	
	else
		echo "I do not know the instance $1";
	fi
fi

