#!/usr/bin/perl
#
# $Id: nc_instances.pl 3464 2010-08-24 13:05:37Z manu $
#
# Copyright INRA/CNRS

# Emmanuel.Courcelle@toulouse.inra.fr
# Jerome.Gouzy@toulouse.inra.fr
# Thomas.Faraut@toulouse.inra.fr

# This software is a computer program whose purpose is to provide a
# web-based interface for analyzing the different levels of genome
# conservations.

# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".

# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.

# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.

# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.


=head1 NAME

 nc_instances.pl

=head1 SYNOPSIS

 chins multi
 nc_instances.pl 

=head1 DESCRIPTION

 Prints the list of instances found in this installation - This may be convenient for use wih a script:
 
 in csh/tcsh, you could write:
 foreach $s (`nc_instances.pl`)
    do_something
 end
 
 in sh/ksh/bash, you could write:
 for $in in `nc_instances.pl`
 do
    do_something
 done
 
=cut

BEGIN
{		# pathway to our modules
		use File::Basename;
		my $dirprg=dirname($0);
		unshift @INC, "$dirprg/../lib";
		unshift @INC, "$dirprg/../API";
}

use strict;
use warnings;
use Configuration::NarcisseObserver;

my $VERSION = do {my @r = (q$Rev: 3464 $ =~ /\d+/g); $r[0]};

# Main program
MAIN:
{
    if  ( exists $ENV { 'NARCISSE_CFG' } )
    {
        my $o_io = New NarcisseObserver();
        print join( ' ',$o_io->GetInstancesNames() );
    }
    else
    {
        die "ERROR - Please execute chins <some_instance> before running this program\n";
    }
}


