#!/usr/bin/perl

# Ce script permet de tester succinctement que les classes
# SlidingWindowCalculator et ThroughSpeciesComputer fonctionnent.



use strict;
use warnings;

use lib qw( ../API ../lib );

# use SlidingWindowCalculator::GCPercentCalculator;
# use SlidingWindowCalculator::GeneSurfaceCalculator;
use SlidingWindowCalculator::SnpDensityCalculator;

use Data::Dumper;

#----------------------------------------
# juste pour eviter d'ecrire dans le repertoire de donnees
package Test;

#use SlidingWindowCalculator::GCPercentCalculator;
# use base qw(GCPercentCalculator);
#use base qw( GeneSurfaceCalculator );
use base qw( SnpDensityCalculator );

sub _ComputeFilepath
{
	return './data.dat';
}
1;

# fin Test
#----------------------------------------

use Logger;

my $window_size = 100_000;
my $step        = $window_size / 2;

my $o_logger = New Logger( '>sliding.log', 'ICV' );

my $o_gc = New Test(
					-species => [ 'human' ],
					-chroms  => [ '21' ],
					-window  => $window_size,
					-step    => $step,
# 					-start   => 1,
# 					-end     => 1_000,
# 					-start   => 6_000_000,
# 					-end     => 7_000_000,

									#~ -graph     => 'tets',
									#~ -feature   => 'gcsk',
									#~ -extension => 'gc',
					 -o_logger  => $o_logger
				 );

# un ComputeData doit avoir des parametre pour etre public !
# sinon, le passer protege
$o_gc->RollOverSpecies( -auto_clean => 1 );

print "done\n";

