<div id="ID_STANDARD_PAGE"  style="background-image: url(#PERLEVAL|$CFG{HTTP_LOGO}#/logo/background.jpg)" >
	<h2 class="doc" id="head"> NARCISSE: a mirror view of conserved syntenies</h2>
	<p>This is NARCISSE <b>Release #PERLEVAL|$CFG{NARCISSE_VERSION}#</b>, the instance name is <b>#PERLEVAL|$CFG{INSTANCE_NAME}#</b>, the instance version <b>#PERLEVAL|$CFG{INSTANCE_VERSION}#</b>.  
	Narcisse is a free software, governed by the <b>license <a href="http://www.cecill.info">CECILL</a> 2</b> - <a href="#PERLEVAL|$CFG{HTTP_DOCUMENTATION}#/license.html">Read the license</a></p>
	
	<h2 class="doc">What is Narcisse ?</h2>
	<p class="doc">Narcisse is a <b>comparative genome browser</b>. It is specifically dedicated to the comparative display and analysis of completely or partially sequenced genomes.
	The aim of this project is to provide an intuitive access to the results of whole genome comparison.</p>
    
	<h2 class="doc" id="preprocessing">Preprocessing</h2>
	<p>In a preprocessing step, the software first <b>detects conserved chromosomal segments</b> by comparing the genomes, in a two-way manner, both at the <b>nucleotide level</b> and at the <b>protein level</b>.
	The construction of conserved segments relies on the principle that the notion of conservation is dependent on the <b>level of resolution</b>.
	At the <b>nucleotide level</b>, the conservation is reflected by sequence alignments. On the opposite side of the scale, at the <b>chromosome level</b>, the conserved syntenies represent shared local chromosomal organization (conserved gene set and order).
	The resulting conservations are organized in a 5-level hierarchy of conservation from the nucleotide level to the chromosomal level. 
	The number of levels is somehow arbitrary and limited to <b>2</b> for the bacterial genomes, <b>5</b> for other kingdoms. The narcisse Web server enables to navigate among these conservations.</p>
	
	<h2 class="doc" id="functionalities">Main functionalities</h2>
	<p>Presently, the following functionnalities are available in Narcisse :</p>
	<ul class="doc"><li>Examine a dotplot of a two-way genome comparison;</li>
	<li>Browse chromosomes of a species of interest together with conserved syntenies with one or two other genomes;</li>
	<li>Display the conservation at different resolution levels;</li>
	<li>Compute the sequence alignment of two conserved syntenies;</li>
	<li>Study protein families.</li></ul>
	
	<h2 class="doc">What is a Narcisse instance ?</h2>
	<p>A Narcisse instance is a complete set of data and program files, who live in a directory hierarchy. 
	However, it is generally more meaningful to maintain several seperate instances, because it should probably make no sense to compare every
	organism against each other; the Narcisse public site groups the organisms in  separate kingdoms (animals, plants, fungi, bacteria)</p>
	<p>A Narcisse instance can also be viewed as dynamic web site, providing the user with a powerful user interface, permitting to dig through the data.</p>
	
	
	<h2 class="doc">The entry points:</h2>
	<p>You can enter the main graphics user interface through 4 different entry points:</p>
	<ol class="doc">
	<li>Using the first entry, you must select two organisms and a comparison method : this brings you to a dotplot graphics, 
	giving a summarized view of the conserved regions. 
	From this dotplot, you can select a chromosome of one of the two organisms as reference for the main genome comparison view, 
	and directly enter the graphics at the chromosome arms level, populating two of the three available tracks.</li>
	<li>Using the second entry, you must provide the program with one or more gene accession numbers: the instance data will be locally searched; 
	even if you specified only one accession, you generally retrieve several results, because a specified gene may be present in several organisms. 
	Every answer may be separately clicked, entering the main representation screen at the gene zoom level, but this time only one track is populated.</li>
	<li>The third form may be fed with a sequence (proteic or nucleic), and a blast will be triggered. The blast results are presented as a set of html links; 
	clicking one of those links leads you to the main visualization program, showing again one organism only, centred on the retrieved region.</li>
	<li>The fourth form is usedul to load a previously saved session.</li>
	</ol>
	
	<p><em>Every page in Narcisse can be bookmarked or hyperlinked.</em></p>
	
	<h2 class="doc">The Graphics User Interface</h2>
	
	<p>The screen is divided in three aeras. the title banner, the control block together with the dynamic legend, and from one to three tracks, 
	representing the genomes being compared:</p>
	
	<ul class="doc">
	<li>In the <em>one track configuration</em>, the drawing represents one chromosome of an organism, with the important objects annotated: genes, 
	repeat segments, rna segments, cytologic data, etc. This chromosome, taken as the reference for all other comparisons, will be called the <em>query chromosome</em>.</li>
	<li>A second track may be added in the left side of the page (the ?subject? in blast parlance), showing, for one particular organism and one specific comparison method, 
	the regions which show a high degree of similarity with the reference organism and chromosome. Please note that on this track, 
	we have a succession of chromosome segments, corresponding to the similarity regions.</li>
	<li>A third track may also be added (a <em>second subject</em>), it will be represented on the right part of the page, 
	so that you can analyze at a glance the similarities between the reference chromosome and 2 organisms, 
	or the similarities between the reference chromosome and 1 organism, but using 2 different comparison methods.</li>
	</ul>
	
	<h2 class="doc" id="map_legend">The legend</h2>
	<p>This is the legend of the main Narcisse maps</p>
	<img src="#PERLEVAL|$CFG{HTTP_DOCUMENTATION}/map_legend.jpg#" alt="The map legend"/>
	
	<h2 class="doc">Controlling the display</h2>
	<p>The control panel (up-left corner) is here to help you controlling the display. There are four tabs:</p>
	<ul class="doc">
	<li><b>Zoom</b>: Tools to scroll and zoom in or out. (<a href="#zoom">more info</a>)</li>
	<li><b>Data</b>: Managing the tracks (<a href="#tracks">more info</a>), uploading your data (<a href="#UserData">more info</a>)</li>
	<li><b>Display</b>: Displaying or hiding some parts of the graphics (<a href="#display">more info</a>)</li>
	<li><b>Session</b>: Creating bookmarks, navigating through those bookmarks, saving your session(<a href="#session">more info</a>) </li>
	</ul>
	
	<h2 class="doc" id="tracks">Managing the tracks:</h2>
	<p>If the graphics shows only one track (if you entered from the second of third entry points as described above), 
	it is possible to add a second track from the Data tab of the control panel (upper-left corner). If the graphics shows two tracks, 
	you may add a third track through the same field. These tracks can also be removed (selecting 'none' as an organism name).
	</p>
	
	<h2 class="doc" id="display">Managing the display:</h2>
	<p>Many display parameters may be adapted from the control panel, display Tab: you can display or hide cytology data (query chromosome only), 
	synteny links, reciprocal best hits, etc. You may also hide the control panel, the dynamic legend, and the menu bars, thanks to the little tool found at left of the menu bar: 
	you enter then the "full screen mode", very convenient to hardcopy the graphics for a publication, for instance.</p>
	
	<h2 class="doc" id="zoom">Controlling the scale and position:</h2>
	<p>A sophisticated zoom tool is available through the control panel, tab Zoom. You can of course zoom in and zoom out or scroll through the query genome, 
	but you have also some predefined zoom levels, which are more meaningful in a biological point of view 
	(chromosome, chromosome arm, synteny segment, genes, gene structure). 
	The exact behaviour of those levels is configured at the instance level, some zoome levels can even be removed for some instances: 
	in the bacteria instance, the gene structure zoom level is quite meaningless and was removed.</p>
	<p>From the same tab, you may also select a numerical position on the reference genome to center the graphics on this position. 
	Another way of doing the same thing is to click the scale of the query chromosome. Furthermore, you may enter a gene name: if found in the query genome, 
	the drawing will be centred on this gene, the gene zoom level will be entered and an arrow will be drawn in front of the gene.</p>
	
	<h2 class="doc" id="info">Getting the information from the graphics</h2>
	<p>Every time you slide your mouse over a graphics object, the object is highlighted and the dynamic legend (lower left corner) is updated,
	displaying all the available information concerning this object. When the mouse hovers the object, it is then possible to click, which makes a contextual 
	popup to appear on the graphics.</p>
	
	<h2 class="doc" id="gene_popup">The Gene popups</h2>
	<ul class="doc">
	<li>Zoom to gene level, the graphics being centered on this gene. 
	If the gene clicked belonged to one of the subject organisms, this subject will be exchanged with the reference organism: 
	this is an interesting way of rapidly modifying the query organism.</li>
	<li>Retrieve from an external URL all available information about this gene.</li> 
	<li>Retrieve from the Narcisse database the gene, cds, or protein sequence</li>
	<li>Call DisplayFam to generate and display a protein family from this sequence, using the data available in Narcisse.</li>
	</ul>
	
	<h2 class="doc" id="synteny_popup">The synteny popup</h2>
	
	<ul class="doc">
    <li>Center to these syntenies: With this item, you can center the graphics around the selected synteny, may be shifting the subject genome.</li>
    <li>Compare these syntenies calls the program ?compare?, for performing a local alignment around the selected synteny. 
    You are brought to another graphics, showing every aligned region. Sliding the mouse on one of those regions opens a new popup, with the possibility to read, 
    and hypertext links to download, the alignment and each sequence.</li>
    <li>Get synteny sequence (one side): get the synteny sequence, but only the side of the synteny you clicked on</li>
    <li>Get synteny sequence (both sides): get the two sequence sides of the synteny</li>
    <li>Get all genes/proteins: Get the seuqneces of all the genes covered by the synteny</li>
	</ul>
    
	<div id="UserData"><h2 class="doc">Uploading your data</h2>
	<p>You may upload personal data through the control panel, Tab Session, to integrate them to the Narcisse view. The data you upload will be integrated to the <em>reference organism</em>.
	You may change the reference organism (clicking on some gene of one of the subject organisms), then upload data related to the new reference organism: the previous uploaded data will be kept. 
	You may also upload several files in several operations, the data related to each organism will be concatenated on the NARCISSE server</p>
	<h3>File format:</h3>
	<p>The file you may upload to NARCISSE is a "CSV" file, the separation character is a TAB</p>
	<table><caption>Format of the data file you may upoad to Narcisse</caption>
	<tr><th>chr</th><th>mandatory</th><td>chromosome name</td></tr>
	<tr><th>element</th><th>mandatory</th><td>some word naming the element to mark</td></tr>
	<tr><th>start</th><th>mandatory</th><td>The starting point of the feature, on the chromosome (1mb, 450kb, 40)</td></tr>
	<tr><th>end</th><th>mandatory</th><td>The end point of the feature, on the chromosome (2mb, 500kb, 60)</td></tr>
	<tr><th>color</th><td>optional</td><td>The colour used to represent the feature, default is blue</td></tr>
	<tr><th>label</th><td>optional</td><td>The displayed label, default is the element name second column)</td></tr>
	</table>
	<h3>An example file</h3>
    
	<pre class="doc">1      elt_1      50     100
	X      elt_2      900kb  1mb      red      some_label</pre>
	
	</div>
    
	<h2 class="doc" id="session">Managing your session</h2>
	<p>The session tab of the control panel lets you manage your session, which means you can define some "bookmarks" 
	(kept in the session directory <em>on the server</em>), and you can save and download the session. 
	All bookmarks and personal data are downloaded and can be later retrieved. 
	<em>Please note that we do not keep any session data on our server</em>, so you are responsible for your data, after download.
	In the same tab, you also have a link for coming back to Dotplot, and another link to go to the Narcisse home page. 
	If you press these links, <em>you stay in the same session</em>, which means you keep your personal data, bookmarks, etc. 
	This gives you the possibility to easily navigate through a lot of genomic comparisons, to go in a couple of clicks from a genomic region to another, 
	or from an organism to another.</p>
	
	<h3 id="load">Loading a previously saved session</h3>
	
	<p>The fourth entry point permits you to load a previously saved session. However, it is only possible to load a session which was 
	saved from <em>the same Narcisse instance</em>, and if the current instance release number is (written at top-left of the screen) is higher than the saved release</p>
	
</div>

