<div id="ID_INSTALL_DOC" class="Documentation" style="background-image: url(#PERLEVAL|$CFG{HTTP_LOGO}#/logo/background.jpg)">

<h1>Installing Narcisse</h1>

<p>This document explains how to install Narcisse on <strong>your</strong> site.</p>
<p>There is also an <a href="#upgrade"><strong>upgrading documentation</strong></a>.</p>

<h2>The prerequisites</h2>

<p>You must have a computer running the GNU/Linux operating system, <strong>only the 64 bits</strong> version.<br />
You must have the following prerequisites to correctly install and run Narcisse:</p>
<ol>
	<li><strong>A C++ compiler</strong>, <code>gcc</code> for example.<br />
	Check your compiler (you should have a 3.xx or 4.xx compiler installed):<pre>g++ --version</pre>
	</li>
	<li><strong>The <code>perl</code></strong> program.<br />
	Check your perl installation (You should have a 5.8.x or 5.10.x release):<pre>perl --version</pre>
	</li>
	<li><strong>An http server</strong>, preferably <code>apache</code>.<br /> 
	Check your http server (you should NOT get a "connexion refused" message): <pre>wget localhost</pre>
	</li>
	<li>The <strong>mail system</strong> should be configured:<br />
	Check your mail installation:<pre>echo "Hello" | mail my_adress@somewhere.org</pre></li>
	<li>You should be able to <code><strong>su</strong></code> or <code><strong>sudo root</strong></code>, or to ask your system administrator to restart the httpd server.<br />
	Except for restarting the web server, it is not required to be root for installing or running Narcisse</li>
</ol>

<h2>Installing Narcisse in 10 steps</h2>

<ol>
	<li>make the directory<pre>mkdir /usr/local/narcisse</pre></li>
	<li>change to this directory and retrieve the software<br /><strong>WARNING</strong> Do not forget to change to the narcisse directory, 
	if you don't you'll get a lot of Narcisse stuff inside the <tt>/usr/local/</tt> directory <pre>cd /usr/local/narcisse
wget http://lipm-bioinfo.toulouse.inra.fr/download/narcisse/narcisse-#PERLEVAL|$nottooshort_version#.tgz
tar xvzf narcisse-#PERLEVAL|$nottooshort_version#.tgz</pre></li>
	<li>Set up the environment:
	<ul><li>If you are using csh/tcsh<pre>source .setenv</pre></li>
	<li>If you are using sh/ksh/bash<pre>source .setenv.sh</pre></li>
	</ul></li>
	<li>Check for required or optional dependencies<pre>nc_check_dependencies.pl</pre>
	<ul>
		<li>If you get a red message, please correct things and try again. Correct things means:
		<ul>
		   <li>to install some perl modules</li>
		   <li>OR to change the path to a Unix utility: please have a look to the file  
		<code>Site.distrib/cfg/unix_cmd.cfg</code></li>
		</ul></li>
		<li>If you get a yellow message, you may want to correct things to have more performance, but this is not required</li>
	</ul></li>
	<li>Install required programs<pre>Core
nc_install_narcisse.pl</pre><em>Press Return if asked any question (default answer)</em></li>
	<li>Install a tiny test instance bacteria_test:
	<ol>
		<li>Create the instance hierarchy using the script <code>nc_configure.pl</code>. You'll be asked a few questions, you should enter:
		<ul>
			<li>The URL of your narcisse installation</li>
			<li>The mail address of the Narcisse administrator</li>
			<li>The genome repository: answer <strong><code>ftp://ftp.ncbi.nih.gov/genomes/Bacteria</code></strong>, so that the program will retrieve data from the ncbi, using ftp.</li>
		</ul>
		The other questions may be unanswered<pre>Narcisse_root
nc_configure.pl --new_instance bacteria_test</pre></li>
		<li>Change to this instance and copy the species cfg files to the correct location:<pre>chins bacteria_test
species
cp bacteria_test/*.cfg .
</pre></li>
		<li>Run again <code>nc_configure.pl</code>, copying the dialog from the following<pre>nc_configure.pl
[...]
Checking directories
Updating species.list
Do you want to create the species.cfg from the repository ? Y/[N] 
Do you want to (re) create a new species.list file ?        Y/[N] Y
	OK    - FOUND xxx - short name yyy
	OK    - FOUND xxx - short name yyy
	OK    - FOUND xxx - short name yyy
Found z species
Now creating narcisse.cfg.dump (this is very useful for debugging )
Now creating config.js (useful for javascript)
Do you want to create a new version of update.sh [Y]/N 
Creating update.sh
Do you want to force all comparisons ? Y/[N] 
How many processors do you want to use for blast ? [1] 2
Do you want self calculations (protein only) ? [N] 
Do you want to use paraloop ? [Y] N 
There are NO genetic_rbh calculations
Files created for the update in directory .../update/update-xxxxxxxx-xx
Do you want to execute update.sh now ? Y/[N]
</pre></li>
		<li>Answer YES to the last question <em>or</em> run the update.sh script:<pre>
		Site
		cd update/update-xxxx
		sh update.sh</pre></li>
		<li>finish the installation of this instance with:<pre>nc_install.pl</pre></li>
</ol></li>
<li>Optional: Redo the step 6, replacing bacteria with fungi (even in the ncbi ftp url)</li>
<li>As root, add the following to your apache configuration<pre>Include /usr/local/narcisse/ApacheConf</pre></li>
<li>As root again, restart Apache - If the Narcisse url does not work, please have a look <a href="http://narcisse.toulouse.inra.fr/wiki/doku.php?id=narcisse_install:global_configuration#the_web_server_configuration">here</a></li>
<li>Test the installation and compare the pictures with our test installations:
    <ul>
	  <li><strong><code><a href="http://narcisse.toulouse.inra.fr/test/#PERLEVAL|$short_version#/bacteria_test/cgi-bin/narcisse.cgi">http://narcisse.toulouse.inra.fr/test/#PERLEVAL|$short_version#/bacteria_test/cgi-bin/narcisse.cgi</a></code></strong></li>
	  <li><strong><code><a href="http://narcisse.toulouse.inra.fr/test/#PERLEVAL|$short_version#/fungi_test/cgi-bin/narcisse.cgi">http://narcisse.toulouse.inra.fr/test/#PERLEVAL|$short_version#/fungi_test/cgi-bin/narcisse.cgi</a></code></strong></li>
	</ul></li>
</ol>

<h2>If you want more details...</h2>

<p>Please have a look to our <strong><a href="http://narcisse.toulouse.inra.fr/wiki/">Documentation wiki</a></strong></p>

<h1 id="upgrade">Upgrading the Narcisse software</h1>

<ol>
	<li>Before any operation, set up the environment:
	<ul><li>If you are using csh/tcsh<pre>source .setenv</pre></li>
	<li>If you are using sh/ksh/bash<pre>source .setenv.sh</pre></li>
	</ul></li>
	<li>A few days before the operation, tell your users that Narcisse will be unavailable during some time, using the "Message Of The Day":<pre>
	chins multi
	nc_configure.pl --motd
	</pre></li>
	<li>A few minutes before upgrading, disable each Narcisse instance:<pre>
	chins multi
	nc_configure.pl --work_in_progress
	chins animals
	nc_configure.pl --work_in_progress
	chins plants
	nc_configure.pl --work_in_progress
	etc...
	</pre></li>
	<li>Change to the directory <code>/usr/local/narcisse</code> and retrieve the software<br /><strong>WARNING</strong> Do not forget to change to the narcisse directory, 
	if you don't you'll get a lot of Narcisse stuff inside the <tt>/usr/local/</tt> directory <pre>cd /usr/local/narcisse
wget http://lipm-bioinfo.toulouse.inra.fr/download/narcisse/narcisse-#PERLEVAL|$nottooshort_version#.tgz
tar xvzf narcisse-#PERLEVAL|$nottooshort_version#.tgz</pre></li>
	<li>Check for required or optional dependencies<pre>nc_check_dependencies.pl</pre>
	<ul>
		<li>If you get a red message, please correct things and try again. Correct things means:
		<ul>
		   <li>to install some perl modules</li>
		   <li>OR to change the path to an Unix utility: please have a look to the file  
		<code>Site.distrib/cfg/unix_cmd.cfg</code></li>
		</ul></li>
		<li>If you get a yellow message, you may want to correct things to have more performance, but this is not required</li>
	</ul></li>
	<li>Install required programs<pre>Core
nc_install_narcisse.pl</pre><em>Press Return if asked any question (default answer)</em></li>
	<li>Upgrade all your instances:<pre>
	chins
	nc_configure.pl --upgrade bacteria_test
	nc_configure.pl --upgrade fungi_test
	nc_configure.pl --upgrade animals
	...
	nc_configure.pl --upgrade multi
	</pre></li>
	<li>Enable all your instances:<pre>
	nc_configure.pl --work_in_progress bacteria_test
	nc_configure.pl --work_in_progress fungi_test
	nc_configure.pl --work_in_progress animals
	...
	nc_configure.pl --work_in_progress multi
	</pre> <em>When you are asked for a message, just press Return: this will remove the previous message and will enable the instance.</em></li>
	
	<li>Test again the installation and compare the pictures with our test installations:
    <ul>
	  <li><strong><code><a href="http://narcisse.toulouse.inra.fr/test/#PERLEVAL|$short_version#/bacteria_test/cgi-bin/narcisse.cgi">http://narcisse.toulouse.inra.fr/test/#PERLEVAL|$short_version#/bacteria_test/cgi-bin/narcisse.cgi</a></code></strong></li>
	  <li><strong><code><a href="http://narcisse.toulouse.inra.fr/test/#PERLEVAL|$short_version#/fungi_test/cgi-bin/narcisse.cgi">http://narcisse.toulouse.inra.fr/test/#PERLEVAL|$short_version#/fungi_test/cgi-bin/narcisse.cgi</a></code></strong></li>
	</ul></li>
</ol>

<h2>If you need some details...</h2>

<p>Please have a look to our <strong><a href="http://narcisse.toulouse.inra.fr/wiki/">Documentation wiki</a></strong></p>
</div>

