/*
  Copyright INRA/CNRS

 Emmanuel.Courcelle@toulouse.inra.fr
 Jerome.Gouzy@toulouse.inra.fr
 Thomas.Faraut@toulouse.inra.fr

 This software is a computer program whose purpose is to provide a
 web-based interface for analyzing the different levels of genome
 conservations.

 This software is governed by the CeCILL license under French law and
 abiding by the rules of distribution of free software.  You can  use,
 modify and/ or redistribute the software under the terms of the CeCILL
 license as circulated by CEA, CNRS and INRIA at the following URL
 "http://www.cecill.info".

 As a counterpart to the access to the source code and  rights to copy,
 modify and redistribute granted by the license, users are provided only
 with a limited warranty  and the software's author,  the holder of the
 economic rights,  and the successive licensors  have only  limited
 liability.

 In this respect, the user's attention is drawn to the risks associated
 with loading,  using,  modifying and/or developing or reproducing the
 software by the user in light of its specific status of free software,
 that may mean  that it is complicated to manipulate,  and  that  also
 therefore means  that it is reserved for developers  and  experienced
 professionals having in-depth computer knowledge. Users are therefore
 encouraged to load and test the software's suitability as regards their
 requirements in conditions enabling the security of their systems and/or
 data to be ensured and,  more generally, to use and operate it in the
 same conditions as regards security.

 The fact that you are presently reading this means that you have had
 knowledge of the CeCILL license and that you accept its terms

*/
/*

=pod

=head1 NAME
 NcCircos.js - Global objects used with the Circos representation

=cut
*/

/*
=pod

=head1 SYNOPSIS

 NarcisseAreaClass               see narcisse_area.js
    ChromosomeCursorClass
    RepeatsClass
	RnaClass
	ExonsClass
    GenesClass
    SyntClass
    HspClass
    PersonalClass

=cut
*/
/* EXPERIMENTAL !	
DraggingClass = Class.create({
			initialize: function(inner_container)
			{
				this.__inner_cont = $(inner_container);
				this.__start_top  = 0;
				this.__top        = 0;
				this.__dragging   = false;
				
				Event.observe(this.__inner_cont,'mousedown',this.__StartMove.bindAsEventListener(this));
				Event.observe(this.__inner_cont,'mousemove',this.__Moving.bindAsEventListener(this));
				Event.observe(this.__inner_cont,'mouseup',this.__StopMove.bindAsEventListener(this));
			},
			
			__StartMove: function(evt)
			{
				this.__start_top = evt.clientY;
				this.__inner_cont.style.cursor = "-moz-grab";
				this.__top = this.__stripPx(this.__inner_cont.style.top);
				this.__dragging = true;
			},
			
			__Moving: function(evt)
			{
				if (this.__dragging)
				{
					this.__inner_cont.setStyle({top: this.__top + (evt.clientY - this.__start_top)});
				}
			},
			
			__StopMove: function(evt)
			{
				this.__inner_cont.style.cursor = "";
				this.__dragging   = false;
			},
			
			__StripPx: function(value)
			{
				if (value == "") return 0;
				return parseFloat(value.substring(0, value.length - 2));
			}
	});
*/
/*      DotplotSyntClass Class      

Constructor Args: 
           top_id       The parent element of the created area
		   x1,y1,x2,y2  The coordinates of the area
		   ... a lot of arguments to be displayed
		   Global:      O_CFG, O_PARAM
*/

CircosChromClass = Class.create(NarcisseAreaClass,{
	initialize: function($super,a_graphics_objects)
	{
		$super(a_graphics_objects);
		this._feature         = 'circos';
	},
	MouseOver: function($super,x1,y1,x2,y2,orga,chrom)
	{
		if ($super(x1,y1,x2,y2) == false ) { return; };
		
		var html='<h2>Circos chromosome</h2>';
		
		html += '<table>';
		//html += '<tr><th>Synteny</th></td>' + synt_id + '</td></tr>';
		html += '<tr><th>Species</th><td>' + orga + '</td></tr>';
		html += '<tr><th>Chromosome</th><td>' + chrom + '</td></tr>';
		html += '</table>';
		$(this._legend).innerHTML=html;
	}
});

// This is a trivial object, just here for the NarcisseArea objects
CircosFeatureClass = Class.create({
	IsFeatureOn: function(feature){return (feature=='circos');},
	UpdatePage:  function(){},
	GetKey:      function(){return 'circos';}
});

/*
=pod

=head2 NcCircosClass

 NcCircosClass derives from NcViewClass
 Private fields are initialized, virtual functions are redefined
 
 Constructor Args:
    a_graphics_objects : A lot of graphics objects
	TODO - Remplacer ca par un objet !

=cut
*/
NcCircosClass = Class.create(NcViewClass,{
		initialize: function($super,a_graphics_objects){
			$super(a_graphics_objects);
			this._script  = 'CIRCOS';
			this._to_hide = ['ID_MENU_GLOBAL','ID_MENU_POSITION','ID_MENU_FEATURES','ID_MENU_TAB_POPUP','ID_VLVL','ID_OVERVIEW'];
			this._to_show = ['ID_LEVEL'];
			O_CIRCOS_CHROM = new CircosChromClass(a_graphics_objects);
		},
			
		/*
=pod
		
=head2 UpdateTitle
		
Title: UpdateTitle
Usage: obj.UpdateTitle()
Procedure: Updates the title table, with the names of reference, target1, target2, ...
Args:     none
Access:   Public
Global: O_CFG, O_PARAM
		
=cut
*/
		UpdateTitle: function()
		{
			var gs = O_CONTROL_BLOCK.GetGensel();
			var html = '<h2>Circos representation</h2>';
			html += this._GetSpeciesNames();
			this._title_div.innerHTML = html;
		}
});

MAIN:
{
	/* Global variables, they will be initialized later */
	O_CIRCOS_CHROM = 0;
};

/*
=pod

=head1 COPYRIGHT NOTICE

This software is governed by the CeCILL license under French law - www.cecill.info

=cut
*/

