/* 
  Copyright INRA/CNRS

 Emmanuel.Courcelle@toulouse.inra.fr
 Jerome.Gouzy@toulouse.inra.fr
 Thomas.Faraut@toulouse.inra.fr

 This software is a computer program whose purpose is to provide a
 web-based interface for analyzing the different levels of genome
 conservations.

 This software is governed by the CeCILL license under French law and
 abiding by the rules of distribution of free software.  You can  use,
 modify and/ or redistribute the software under the terms of the CeCILL
 license as circulated by CEA, CNRS and INRIA at the following URL
 "http://www.cecill.info".

 As a counterpart to the access to the source code and  rights to copy,
 modify and redistribute granted by the license, users are provided only
 with a limited warranty  and the software's author,  the holder of the
 economic rights,  and the successive licensors  have only  limited
 liability.

 In this respect, the user's attention is drawn to the risks associated
 with loading,  using,  modifying and/or developing or reproducing the
 software by the user in light of its specific status of free software,
 that may mean  that it is complicated to manipulate,  and  that  also
 therefore means  that it is reserved for developers  and  experienced
 professionals having in-depth computer knowledge. Users are therefore
 encouraged to load and test the software's suitability as regards their
 requirements in conditions enabling the security of their systems and/or
 data to be ensured and,  more generally, to use and operate it in the
 same conditions as regards security.

 The fact that you are presently reading this means that you have had
 knowledge of the CeCILL license and that you accept its terms
 
*/


/* 

=pod

=head1 NAME

 blast_form.js - Code related to the "Blast" form on the home page

=head1 SYNOPSIS

 NarcisseFormClass        see narcisse.js
    BlastFormClass

=cut
*/

/*
=pod

=head2 BlastFormclass

   BlastFormClass ==> Extends NarcisseFormClass
                      Connected to blast_form.inc
   XHTML LAYOUT:
   =============
   <form>
         <element with id="BlastExemple">
    </form>

=pod

=head2 BlastFormClass

 Title        : BlastFormClass
 Usage        : The behaviour associated to the form "Blast" from the home page
 Constructor arg : top_div        The container

=cut

*/
BlastFormClass = Class.create(NarcisseFormClass,{
	initialize: function($super,top_id)
	{
		$super(top_id);
		
		// Observe the submit button AND the reset button
		var button = this.form.down('.button');
		var reset  = button.next('.button');
		Event.observe(button,'click',this.SubmitForm.bindAsEventListener(this));
		Event.observe(reset,'click',this.InitForm.bindAsEventListener(this));
		
		// Initialize the form
		this.InitForm();
	},
	InitForm: function()
	{
		//InitForm(this.form,this.gui_defaults);
		InitForm(this.form,O_PARAM);

		// Keep track of the sequence and UploadData fields
		this.__sequence = this.form.down('textarea');
		this.__f_upload = this.__sequence.next('.button');
		
		// Clear them
		SetValue(this.__sequence,'');
		SetValue(this.__f_upload,'');
		
		// Observe the example only if a blast example was defined
		var elt = $( 'BlastExample' );
		if (O_PARAM['blast_example'] != undefined)
		{
			elt.style.cursor='pointer';
			//les params de la fonction
			var args = O_PARAM['blast_example'];
			var params = '__wb_function=ServiceFromLocus&service=protein&args=' + escape( args );
			this_obj = this;
			Event.observe( elt, 'click', function( evt ) {
				
				// TODO - Renvoyer sur un o_error !!!
				var o_ajax = new LipmAjaxDataClass();
				o_ajax.UnsetAsynchronous();
				o_ajax.SubmitAjax(params);
				var json_data = o_ajax.GetData();
				
				//text area
				var text_area = this_obj.form['sequence'];
				text_area.value = $H( json_data ).get('seq');
				
				//prog
				var select_elt = this_obj.form['blast_prog'];
				select_elt.value = 'blastp';
			} );
		}
		else
		{
			elt.hide();
		}
		
		// Initialize the form
		//
			elt.style.cursor='pointer';
			//les params de la fonctionthis.InitForm();
	},

/*
    CleanInput = SUPPRIME LES CARACTERES FOIREUX DU CHAMP AVANT DE L'ENVOYER
	TODO - IL FAUDRAIT INTEGRER CA A WFORMS !
*/
	CleanInput: function()
	{
		var inp = $F(this.form['sequence']);
		var inp1= inp.gsub(/[|()\#;]/," ");
		this.form['sequence'].value = inp1;
	},
	
	SubmitForm: function(evt)
	{
		this.CleanInput();
	}	
})


/*
=pod

=head1 COPYRIGHT NOTICE

This software is governed by the CeCILL license under French law - www.cecill.info

=cut
*/


