/* 
  Copyright INRA/CNRS

 Emmanuel.Courcelle@toulouse.inra.fr
 Jerome.Gouzy@toulouse.inra.fr
 Thomas.Faraut@toulouse.inra.fr

 This software is a computer program whose purpose is to provide a
 web-based interface for analyzing the different levels of genome
 conservations.

 This software is governed by the CeCILL license under French law and
 abiding by the rules of distribution of free software.  You can  use,
 modify and/ or redistribute the software under the terms of the CeCILL
 license as circulated by CEA, CNRS and INRIA at the following URL
 "http://www.cecill.info".

 As a counterpart to the access to the source code and  rights to copy,
 modify and redistribute granted by the license, users are provided only
 with a limited warranty  and the software's author,  the holder of the
 economic rights,  and the successive licensors  have only  limited
 liability.

 In this respect, the user's attention is drawn to the risks associated
 with loading,  using,  modifying and/or developing or reproducing the
 software by the user in light of its specific status of free software,
 that may mean  that it is complicated to manipulate,  and  that  also
 therefore means  that it is reserved for developers  and  experienced
 professionals having in-depth computer knowledge. Users are therefore
 encouraged to load and test the software's suitability as regards their
 requirements in conditions enabling the security of their systems and/or
 data to be ensured and,  more generally, to use and operate it in the
 same conditions as regards security.

 The fact that you are presently reading this means that you have had
 knowledge of the CeCILL license and that you accept its terms
 
*/


/*

=pod

=head1 NAME

 upload_form.js - Code related to the "Upload" form on the home page

=head1 SYNOPSIS

=cut

*/

UploadFormClass = Class.create(NarcisseFormClass,{

	initialize: function($super, top_id, o_data_source, o_error, o_exp, o_controlblock )
	{
		// Create 1 object for autocompletion
		// <form><div><input /><div></div></div></form>
		$super(top_id);
		this.__genome_input = this.form.down('div').down('div').down('input');

		var id  = this.__genome_input.identify();
		var div = this.__genome_input.next('div');

		var autocomplete = new YAHOO.widget.AutoComplete( id, div, o_data_source );
		autocomplete.forceSelection = true;

		var button = this.form.down('.button');
		Event.observe(button,'click',this.SubmitForm.bindAsEventListener(this));

		// Initialize the form = set __wb_session
		//InitForm( $(form_id), O_PARAM );
		//InitForm(this.form,this.gui_defaults);
		//InitForm(this.form,O_PARAM);
		//this.InitForm();
	},
/*
    CleanInput = SUPPRIME LES CARACTERES FOIREUX DU CHAMP AVANT DE L'ENVOYER
	TODO - IL FAUDRAIT INTEGRER CA A WFORMS !
*/
	CleanInput: function()
	{
		var inp = $F(this.form['sequence']);
		var inp1= inp.gsub(/[|()\#]/," ");
		this.form['sequence'].value = inp1;
	},
	
	SubmitForm: function(evt)
	{
		this.CleanInput();
	}	
});
/* UploadFormClass */


/*
=pod

=head1 COPYRIGHT NOTICE

This software is governed by the CeCILL license under French law - www.cecill.info

=cut
*/