/* 
  Copyright INRA/CNRS

 Emmanuel.Courcelle@toulouse.inra.fr
 Jerome.Gouzy@toulouse.inra.fr
 Thomas.Faraut@toulouse.inra.fr

 This software is a computer program whose purpose is to provide a
 web-based interface for analyzing the different levels of genome
 conservations.

 This software is governed by the CeCILL license under French law and
 abiding by the rules of distribution of free software.  You can  use,
 modify and/ or redistribute the software under the terms of the CeCILL
 license as circulated by CEA, CNRS and INRIA at the following URL
 "http://www.cecill.info".

 As a counterpart to the access to the source code and  rights to copy,
 modify and redistribute granted by the license, users are provided only
 with a limited warranty  and the software's author,  the holder of the
 economic rights,  and the successive licensors  have only  limited
 liability.

 In this respect, the user's attention is drawn to the risks associated
 with loading,  using,  modifying and/or developing or reproducing the
 software by the user in light of its specific status of free software,
 that may mean  that it is complicated to manipulate,  and  that  also
 therefore means  that it is reserved for developers  and  experienced
 professionals having in-depth computer knowledge. Users are therefore
 encouraged to load and test the software's suitability as regards their
 requirements in conditions enabling the security of their systems and/or
 data to be ensured and,  more generally, to use and operate it in the
 same conditions as regards security.

 The fact that you are presently reading this means that you have had
 knowledge of the CeCILL license and that you accept its terms
 
*/

/*
=pod

=head1 NAME

 home.js

=head1 SYNOPSIS

 The functions in this file are executed when the home page is loaded

=head1 PREREQUISTE

 O_CFG must be already initialized
 We must NOT live inside a popup

=cut

*/

/*
=pod

=head2 Load

 Title       : Load
 Usage       : Executed when the page is loaded
               Some objects are created and configured
 
=cut

*/
	
MAIN:
{
	function Load()
	{

		// if O_PARAM undefined, we return (could happen in popups)
		try
		{
			if ((O_PARAM['script']!=undefined && O_PARAM['script']!='HOME') || IsPopup())
				return;
		}
		catch(e){return;};
			
		var o_data_source  = new YAHOO.widget.DS_JSArray( GetSpeciesList() );
		o_data_source.queryMatchCase     = false;
		o_data_source.queryMatchContains = true;

		var o_error = new LipmPopupYUIClass('ID_ERROR');

		if (O_PARAM.advanced == undefined || O_PARAM.advanced == 0)
		{
			try
			{
				var gensel = new GenselTinyFormClass( 'ID_GENSEL_TINY', o_data_source, o_error);
			}
			catch(e){};
		}
		else
		{
			var e;
			try
			{			
				e = new ExpandableClass('ID_GENSEL',1,(O_PARAM.gensel_form_open==undefined)?false:Boolean(O_PARAM.gensel_form_open));
				e.SetBehaviour('one_expanded');
				var gensel = $('ID_GENSEL_FORM').up('div');		// PROVISOIRE	
				O_GENSEL = new GenselFormClass(gensel,o_data_source,o_error);
			}
			catch(e){};
			
			try
			{	
				e = new ExpandableClass('ID_ACCESS',1,(O_PARAM.access_form_open==undefined)?false:Boolean(O_PARAM.access_form_open));
				e.SetBehaviour('one_expanded');
				new NarcisseFormClass('ID_ACCESS');
			}
			catch(e){};
	
			try
			{
				e = new ExpandableClass('ID_UPLOAD',1,(O_PARAM.upload_form_open==undefined)?false:Boolean(O_PARAM.upload_form_open));
				e.SetBehaviour('one_expanded');
				new UploadFormClass( 'ID_UPLOAD', o_data_source, o_error );
			}
			catch(e){};
	
			try
			{
				e = new ExpandableClass('ID_BLAST',1,(O_PARAM.blast_form_open==undefined)?false:Boolean(O_PARAM.blast_form_open));
				e.SetBehaviour('one_expanded');
				new BlastFormClass('ID_BLAST','ID_HOME_AJAX','ID_AJAX_ERROR');
			}
			catch(e){};
	
			try
			{
				e = new ExpandableClass('ID_LOAD',1,(O_PARAM.load_form_open==undefined)?false:Boolean(O_PARAM.load_form_open));
				e.SetBehaviour('one_expanded');
			}
			catch(e){};
		}
	}
	Event.observe(window,'load',Load);
}

/*
=pod

=head1 COPYRIGHT NOTICE

This software is governed by the CeCILL license under French law - www.cecill.info

=cut
*/
