/* 
  Copyright INRA/CNRS

 Emmanuel.Courcelle@toulouse.inra.fr
 Jerome.Gouzy@toulouse.inra.fr
 Thomas.Faraut@toulouse.inra.fr

 This software is a computer program whose purpose is to provide a
 web-based interface for analyzing the different levels of genome
 conservations.

 This software is governed by the CeCILL license under French law and
 abiding by the rules of distribution of free software.  You can  use,
 modify and/ or redistribute the software under the terms of the CeCILL
 license as circulated by CEA, CNRS and INRIA at the following URL
 "http://www.cecill.info".

 As a counterpart to the access to the source code and  rights to copy,
 modify and redistribute granted by the license, users are provided only
 with a limited warranty  and the software's author,  the holder of the
 economic rights,  and the successive licensors  have only  limited
 liability.

 In this respect, the user's attention is drawn to the risks associated
 with loading,  using,  modifying and/or developing or reproducing the
 software by the user in light of its specific status of free software,
 that may mean  that it is complicated to manipulate,  and  that  also
 therefore means  that it is reserved for developers  and  experienced
 professionals having in-depth computer knowledge. Users are therefore
 encouraged to load and test the software's suitability as regards their
 requirements in conditions enabling the security of their systems and/or
 data to be ensured and,  more generally, to use and operate it in the
 same conditions as regards security.

 The fact that you are presently reading this means that you have had
 knowledge of the CeCILL license and that you accept its terms
 
*/

/*
=pod

=head1 NAME

 home_multi.js

=head1 SYNOPSIS

 The functions in this file are executed when the home page is loaded (multi instances)

*/

/*
=pod

=head2 Load

 Title       : Load
 Usage       : Executed when the page is loaded
               Some events are observed
 
=cut

*/
	
MAIN:
{
	/*
=pod
	
=head2 NewWindow
	
 Title:     Newwindow
 Usage:     NewWindow('some_url')
 Procedure: Open a new window
 Args:      url The url to get
 popup If true, 
 Global :   none
	
 =cut
	
	*/
	
	function NewWindow(evt)
	{
		var elt = evt.element();
		if (elt.href==undefined) {elt=elt.up();};
		var url=elt.href;
		if (url != undefined)
		{
			window.open(url);
			evt.stop();
		}
	}
	
	
	function Load()
	{
		var a_instance_links = $$('.instance_link');
		for (var i=0; i<a_instance_links.length; ++i)
		{
			Event.observe(a_instance_links[i],'click',NewWindow);
		}
	}	
	
	Event.observe(window,'load',Load);
};

/*
=pod

=head1 COPYRIGHT NOTICE

This software is governed by the CeCILL license under French law - www.cecill.info

=cut
*/

